#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

struct Ukaz
{
   char Key;  
   int Count; 
   Ukaz* Prev;//  p  .
              //p "p" -
              //p (   p p!)
   Ukaz* Left;
   Ukaz* Right;
};

class Tree
{
  private:
    Ukaz* Root; //   .
  public:
    Tree () { //pp   p.
              Root = new (Ukaz); Root->Right = NULL;};
    void PrintTree (Ukaz*, int);
    void Search (char);
    void Prufer (Ukaz*);
    Ukaz* GetTree() {return Root;};
};

// ------------    ----------
void Tree::PrintTree (Ukaz* W, int l)
{
  int i;

  if  (W!=NULL)
  {
	 PrintTree (W->Right,l+1);
	 for (i=1;i<=l;i++) cout << "   ";
	 cout << W->Key << endl;
	 PrintTree (W->Left,l+1);
  }
}

void Tree::Search (char x)
{
  Ukaz *p1,*p2;
  int d;

  p2 = Root; p1 = p2->Right; d = 1;
  while  (p1!=NULL && d!=0)
  {
	  p2 = p1;
	  if  (x < p1->Key)
		{ p1 = p1->Left; d = -1; }
	  else
            if  (x > p1->Key) { p1 = p1->Right; d = 1; }
            else  d = 0;
  }
  if  (d==0) p1->Count += 1;
  else
  {
	 p1 = new (Ukaz);
	 p1->Key = x; p1->Left = p1->Right = NULL; p1->Count = 1;
	 if  (d<0)
	 {
		 p2->Left = p1;
		 p1->Prev = p2;
	 }
	 else
	 {
		 p2->Right = p1;
		 p1->Prev = p2;
	 }
  }
}

void Tree::Prufer (Ukaz* R)
{
  if (R!=NULL)
  {
    Prufer (R->Left);
    Prufer (R->Right);
    cout << R->Prev->Key  << " ";
  }
}

void main()
{
  Tree A;
  char k;
  // p pp "p" p:                         
  //                           -----                                
  //                            *  Root                           
  //                           --+--                                
  //                                                               
  //           ------------------v---------------------    
  //           Key Count       *            
  //           --------------------+-------------------             
  //                                Root->Right                    
  //                                                               
  //           --------------------v-------------------             
  //           Key Count   *   *       p    
  //           ---------------+----+-+-----------------             
  // Root->Right->Left---------    -------- Root->Right->Right     
  //                  v                    v                        
  //                 ...                  ...                       
  // pp p      p.
  cout << " ...\n";
  cout << "   \"#\"...\n";
  cin >> k;
  while (k!='#')
  {
    A.Search(k); 
    cin >> k;
  }
  cout << endl;
  if (A.GetTree() == NULL) //  p , ... 
    { cout << "p !\n"; exit; }
  A.PrintTree (A.GetTree()->Right,0);
  // p  p   pp  p.
  cout << "   pp  p \n";
  A.Prufer (A.GetTree()->Right); 
}
